#include <stdio.h>
#define isblack(a,b) ((a)<0||(b)<0||(a)>=w||(b)>=h)?0:(buf[(b)*w+(a)] & 0x00FFFFFF)?0:1
#define iswhite(a,b) ((a)<0||(b)<0||(a)>=w||(b)>=h)?1:(buf[(b)*w+(a)] & 0x00FFFFFF ^ 0x00FFFFFF)?0:1
int c=0;

typedef char matrix[3][3];


void reqpix(int w,int h,int x0, int y0,int *buf)
{
char mat[5][5];
int x,y,more,white_connex=0,black_connex=0,current_connex;

for(x=0; x<5; x++) for(y=0; y<5; y++) mat[x][y]=' ';
for(x=1; x<4; x++) for(y=1; y<4; y++) mat[x][y] =((buf[(y0+y-2)*w+(x0+x-2)] & 0x00FFFFFF)?0:1)? 'b' : 'w';

more=1;
current_connex=' ';
for(x=1; x<4 && more; x++) 
	for(y=1; y<4 && more; y++) {
		if(mat[x][y]=='v') continue;
		if(mat[x][y] != current_connex) {
			current_connex = mat[x][y];
			if(current_connex=='b' && !black_connex) black_connex++; 
			else if (current_connex=='w' && !white_connex) white_connex++;
	  		else if((mat[x][y-1]!=current_connex  || mat[x][y-1] != 'v') &&
		  		(mat[x][y+1]!=current_connex  || mat[x][y+1] != 'v')  &&
			  	(mat[x+1][y-1]!=current_connex  || mat[x+1][y-1] != 'v')  &&
			  	(mat[x+1][y+1]!=current_connex  || mat[x+1][y+1] != 'v')  &&
	  			(mat[x-1][y-1]!=current_connex  || mat[x-1][y-1] != 'v')  &&
	  			(mat[x-1][y+1]!=current_connex  || mat[x-1][y+1] != 'v')  &&
	  			(mat[x+1][y]!=current_connex  || mat[x+1][y] != 'v')  &&
	  			(mat[x-1][y]!=current_connex || mat[x-1][y] != 'v')  
			) {
				if(current_connex=='b') black_connex++; else white_connex++;
			}
			if (black_connex > 1  || white_connex > 1) more=0;
		}	
		if(!more) break;
		mat[x][y]='v';
	  	if(mat[x][y-1]==current_connex) mat[x][y-1]='v';
	  	if(mat[x][y+1]==current_connex) mat[x][y+1]='v';
	  	if(mat[x+1][y-1]==current_connex) mat[x+1][y-1]='v';
	  	if(mat[x+1][y+1]==current_connex) mat[x+1][y+1]='v';
	  	if(mat[x-1][y-1]==current_connex) mat[x-1][y-1]='v';
	  	if(mat[x-1][y+1]==current_connex) mat[x-1][y+1]='v';
	  	if(mat[x+1][y]==current_connex) mat[x+1][y]='v';
	  	if(mat[x-1][y]==current_connex) mat[x-1][y]='v';
	}
for(y=0; y<3; y++) {
	for(x=0; x<3; x++) printf("%1u",buf[y*w+x]);
	printf("\n");
}
printf("parties  connexes noires = %u\n",black_connex);
printf("parties  connexes blanches = %u\n",white_connex);

} /* reqpix */
void gen(char *s,int n) 
{ int i,l;
char t[5];
if(n==8) {
	n=0;
	if(s[3]=='0'){
		strcpy(s,"");
		return;
	}
	printf("%2u",c++);
	for(i=0; i<3; i++) {
		strncpy(t,&(s[i*3]),3);
		t[3]=0;
		printf("   %s\n",t);
	}
	printf("\n");
	return;
}
l=strlen(s);
s[l]='0';
s[l+1]=0;
gen(s,n+1);
s[l]='1';
s[l+1]=0;
gen(s,n+1);
}

void propagation(matrix mat, char color)
{
int x,y,i,j;

for(x=0; x<3; x++) 
	for(y=0; y<3; y++) {
		if(mat[x][y] == 'v') {
			for(i=0; i<3; i++) 
				for(j=0; j<3; j++) 
					if(abs(i-x)<2 && abs(j-y)<2 && mat[i][j]==color) mat[i][j]='v';
		}
	}
}


int get_connex_number(matrix m, int color)
{ int x,y,connex=0;
matrix mat;

for(y=0; y<3; y++) 
	for(x=0 ; x<3; x++) mat[x][y] = m[x][y];

for(y=0; y<3; y++) 
	for(x=0 ; x<3; x++) {
		if (mat[x][y]==((color=='b')? 'w' : 'b') || mat[x][y]=='v') continue;
		connex++;
		mat[x][y]='v';
		propagation(mat,color);
	}

return connex;
}

int is_this_pixel_required(int w,int h,int x0, int y0,int *buf)
{
int x,y,ax,ay,xx,yy,i,j,connex;
char mat[3][3];
int more;

for(y= -1; y<2; y++) {
	for(x= -1; x<2; x++) {
		mat[x+1][y+1] = (isblack(x0+x,y0+y))?'b':'w';
		printf("%c",mat[x+1][y+1]);
	}
	printf("\n");
}

connex=0;
for(y=0; y<3; y++) 
for(x=0 ; x<3; x++){ 
		if (mat[x][y]=='w' || mat[x][y]=='v') continue;
		connex++;
		mat[x][y]='v';
		xx=x;
		yy=y;
		do {
			more=0;
			for(i=0; i<3; i++) 
				for(j=0; j<3; j++) 
					if(abs(i-xx)<2 && abs(j-yy)<2 && mat[i][j]=='b') {
						mat[i][j]='v';
						ax=i;
						ay=j;
						more=1;
					}
			xx=ax;
			yy=ay;
		} while(more);
	}
/* if(connex==1) return 0; */
printf("black 8-connex=%u\n",connex);

for(x= -1; x<2; x++) { 
	for(y= -1; y<2; y++) {
		mat[x+1][y+1] = (isblack(x0+x,y0+y))?'b':'w';
	}
}

connex=0;
for(y=0; y<3; y++) 
	for(x=0 ; x<3; x++) {
		if (mat[x][y]=='b' || mat[x][y]=='v') continue;
		connex++;
		mat[x][y]='v';
		xx=x;
		yy=y;
		do {
			more=0;
			for(i=0; i<3; i++) 
				for(j=0; j<3; j++) 
					if( (i==xx && abs(j-yy)==1 || j==yy && abs(i-xx)==1) 
						&& mat[i][j]=='w') {
							mat[i][j]='v';
							ax=i;
							ay=j;
							more=1;
					}
			xx=ax;
			yy=ay;
		} while(more);
	}
/* if(connex==1) return 0; else return 1; */
printf("white 4-connex=%u\n",connex);

} /* is_this_pixel_required */

main()
{
char t[30];
int k,i,j;

matrix buf[9]={
{'w','b','w','b','w','b','w','b','w'},
{'b','w','b','w','b','w','b','w','b'},
{'w','b','w','w','b','b','w','w','w'},
{'b','w','w','b','b','w','b','b','w'},
{'b','b','w','w','w','w','w','b','b'},
{'b','b','b','w','w','w','w','b','w'},
{'b','b','w','w','w','w','b','b','w'},
{'b','w','b','b','b','w','w','b','w'},
{'b','b','b','w','w','b','w','b','b'}
};
/* strcpy(t,"");
 gen(t,0);*/

for(k=0; k<9; k++) {
	for(j=0; j<3; j++) {
		for(i=0; i<3; i++) 
				printf("%c",buf[k][j][i]);
		printf("\n");
	}
	printf("black = %u  white = %u\n",get_connex_number(buf[k],'b'), get_connex_number(buf[k],'w'));
}

}
