/**************************************/
/* thining by Tohm algorithm */
/* Tarik Fdil <tfdil@sagma.ma> */
/* april 2005 */
/* Licence GPL cf. http://www.gnu.org */
/**************************************/
#include <tiffio.h>
#define isblack(a,b) ((a)<0||(b)<0||(a)==w||(b)==h)?0:(buf[(b)*w+(a)] & 0x00FFFFFF)?0:1
#define iswhite(a,b) ((a)<0||(b)<0||(a)==w||(b)==h)?1:(buf[(b)*w+(a)] & 0x00FFFFFF ^ 0x00FFFFFF)?0:1
#define min(a,b) ((a) < (b))? (a) : (b)
#define max(a,b) ((a) > (b))? (a) : (b)

void tohme(uint32 w, uint32 h,uint32 *buf)
{
int n,more,x,y,c,white=0xffffffff;
int pa,pb,pc,pd,pe,pf,pg,ph,pi;

do {
      	more=0;
    	for (x=0; x<w; x++)
	for (y=0; y<h; y++)
	{	if(iswhite(x,y)) continue; 
		pb = isblack(x,y+1);
		ph = isblack(x,y-1);
		pa = isblack(x-1,y+1);
		pd = isblack(x-1,y);
		pg = isblack(x-1,y-1);
		pc = isblack(x+1,y+1);
		pf = isblack(x+1,y);
		pi = isblack(x+1,y-1);
 		if ( 	
 		     	pb && pd && ph && !pf  ||
			!pb && pd && ph && pf  ||
 		     	pb && !pd && ph && pf  ||
 		     	pb && pd && !ph && pf  ||
			!pa && !pb && !pc && !pd && !pf && ph && pi ||
			!pa && !pb && !pc && !pd && !pf && ph && pg ||
			pa && pb && !pd && !pf && !pg && !ph && !pi ||
			pc && pb && !pd && !pf && !pg && !ph && !pi ||
			!pa && !pb && !pd && pf && !pg && !ph && pi ||
			!pa && !pb && !pd && pf && !pg && !ph && pc ||
			!pb && !pc && pd && !pf && pg && !ph && !pi ||
			!pb && !pc && pd && !pf && pa && !ph && !pi ||
			!pb && !pc && pd && !pf && ph ||
			!pa && !pb && !pd && pf && ph ||
			pb && !pd && pf && !pg && !ph ||
			pb && pd && !pf && !ph && !pi
		) { 
			buf[y*w+x]=white;
			more=1;
		}
	}
} while(more);


} /* tohme */
