/**************************************/
/* trim_bitmap.c  : suppress leading and trailing white space in a bitmap
/* Tarik Fdil <tfdil@sagma.ma> */
/* mars 2005 */
/* Licence GPL cf. http://www.gnu.org */
/**************************************/

#define isblack(x,y) (buf[(y)*w+(x)] & 0x00FFFFFF)?0:1
#define S 0

void trim_bitmap(unsigned int w, unsigned int h,unsigned int *buf,int *y1,int *y2)
{
int x,y,ok;

ok=1;
for(y=0; y<h && ok; y++) {
	for(x=0; x<w && ok; x++) if(isblack(x,y)) ok=0;
}
*y1 = y-1;
ok=1;
for(y=h-1; y>=0 && ok; y--) {
	for(x=0; x<w && ok; x++) if(isblack(x,y)) ok=0;
}
*y2 = y+1;

}
